*$ CREATE MGDRAW.FOR
*COPY MGDRAW
*                                                                      *
*=== mgdraw ===========================================================*
*                                                                      *
      SUBROUTINE MGDRAW ( ICODE, MREG )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1990-2006      by        Alfredo Ferrari           *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     MaGnetic field trajectory DRAWing: actually this entry manages   *
*                                        all trajectory dumping for    *
*                                        drawing                       *
*                                                                      *
*     Created on   01 march 1990   by        Alfredo Ferrari           *
*                                              INFN - Milan            *
*     Last change  05-may-06       by        Alfredo Ferrari           *
*                                              INFN - Milan            *
*                                                                      *
*----------------------------------------------------------------------*
*
      INCLUDE '(CASLIM)'
      INCLUDE '(COMPUT)'
      INCLUDE '(SOURCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(GENSTK)'
      INCLUDE '(MGDDCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(QUEMGD)'
      INCLUDE '(SUMCOU)'
      INCLUDE '(TRACKR)'
      INCLUDE '(GOMLOC)'
*
      INCLUDE '(RESNUC)'
*
      DIMENSION DTQUEN ( MXTRCK, MAXQMG )
*
      CHARACTER*20 FILNAM
      LOGICAL LFCOPE
      SAVE LFCOPE
      DATA LFCOPE / .FALSE. /

      REAL*4 NuclBeforeTUP(17)
      REAL*4 NuclAfterTUP(17)
*
*----------------------------------------------------------------------*
*                                                                      *
*     Icode = 1: CALL from Kaskad                                      *
*     Icode = 2: CALL from Emfsco                                      *
*     Icode = 3: CALL from Kasneu                                      *
*     Icode = 4: CALL from Kashea                                      *
*     Icode = 5: CALL from Kasoph                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
c         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
c     &          'UNFORMATTED' )
      END IF


c      WRITE (IODRAW) NTRACK, MTRACK, JTRACK, SNGL (ETRACK),
c     &               SNGL (WTRACK)
c      WRITE (IODRAW) ( SNGL (XTRACK (I)) , SNGL (YTRACK (I)), 
c     &                 SNGL (ZTRACK (I)), I = 0, NTRACK ),
c     &               ( SNGL (DTRACK (I)), I = 1, MTRACK ),
c     &                 SNGL (CTRACK)

*  +-------------------------------------------------------------------*
*  |  Quenching is activated
      IF ( LQEMGD ) THEN
         RULLL = ZERZER
         CALL QUENMG ( ICODE, MREG, RULLL, DTQUEN )
C         WRITE (IODRAW) ( ( SNGL (DTQUEN (I,JBK)), I = 1, MTRACK ),
C     &                      JBK = 1, NQEMGD )
      END IF
*  |  End of quenching

*     check that ??!?!

c      WRITE (IODRAW) NTRACK, MTRACK, JTRACK, SNGL (ETRACK),
c     &               SNGL (WTRACK)
c      WRITE (IODRAW) ( SNGL (XTRACK (I)) , SNGL (YTRACK (I)), 
c     &                 SNGL (ZTRACK (I)), I = 0, NTRACK ),
c     &               ( SNGL (DTRACK (I)), I = 1, MTRACK ),
c     &                 SNGL (CTRACK)

C         WRITE (IODRAW) ( ( SNGL (DTQUEN (I,JBK)), I = 1, MTRACK ),
C     &                      JBK = 1, NQEMGD )

*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     Boundary-(X)crossing DRAWing:                                    *
*                                                                      *
*     Icode = 1x: CALL from Kaskad                                     *
*             19: boundary crossing                                    *
*     Icode = 2x: CALL from Emfsco                                     *
*             29: boundary crossing                                    *
*     Icode = 3x: CALL from Kasneu                                     *
*             39: boundary crossing                                    *
*     Icode = 4x: CALL from Kashea                                     *
*             49: boundary crossing                                    *
*     Icode = 5x: CALL from Kasoph                                     *
*             59: boundary crossing                                    *
*                                                                      *
*======================================================================*
*                                                                      *
*     Jtrack         = identity number of the particle                 *
*     Etrack         = total energy of the particle                    *
*     Am             = mass energy of the particle                     *
*     Cx,y,ztrck     = direction cosines of the current particle       *
*     Mreg           = region number before the boundary crossing      *
*     Newreg         = region number after the boundary crossing       *
*     xco,yco,zco    = coordinates of the particle at boundary crossing*

      ENTRY BXDRAW ( ICODE, MREG, NEWREG, XSCO, YSCO, ZSCO )

c     target entrance surface      
      IF(MREG.EQ.8.AND.NEWREG.EQ.9)THEN
         IF(JTRACK.GE.-6.AND.JTRACK.LE.-2)THEN
            IF(ETRACK.GT.AM(JTRACK))THEN     ! Ion has survived
               IF(JTRACK.EQ.-6) IZ=2 ; IA=4 ; NHe4 = NHe4 +1
               IF(JTRACK.EQ.-5) IZ=2 ; IA=3 ; NHe3 = NHe3 +1
               IF(JTRACK.EQ.-4) IZ=1 ; IA=3 ; NH3 = NH3 +1
               IF(JTRACK.EQ.-3) IZ=1 ; IA=2 ; NH2 = NH2 +1
               IF(JTRACK.EQ.-2) IZ=ICRES ; IA=IBRES ; NHI = NHI +1
               NuclBeforeTUP(1) = JTRACK
               NuclBeforeTUP(2) = ETRACK
               NuclBeforeTUP(3) = ETRACK-AM(JTRACK)
               NuclBeforeTUP(4) = XSCO
               NuclBeforeTUP(5) = YSCO
               NuclBeforeTUP(6) = ZSCO
               NuclBeforeTUP(7) = CXTRCK
               NuclBeforeTUP(8) = CYTRCK
               NuclBeforeTUP(9) = CZTRCK
               NuclBeforeTUP(10)= MREG
               NuclBeforeTUP(11)= ICRES
               NuclBeforeTUP(12)= IBRES
               NuclBeforeTUP(13)= ERES
               NuclBeforeTUP(14)= EKRES
               NuclBeforeTUP(15)= PXRES
               NuclBeforeTUP(16)= PYRES
               NuclBeforeTUP(17)= PZRES
              CALL HFN(110,NuclBeforeTUP)
            ENDIF
	 ENDIF
      ENDIF

c     target exit surface
      IF(MREG.EQ.9.AND.NEWREG.EQ.10)THEN
         IF(JTRACK.GE.-6.AND.JTRACK.LE.-2)THEN
            IF(ETRACK.GT.AM(JTRACK))THEN     ! Ion has survived
               IF(JTRACK.EQ.-6) IZ=2 ; IA=4 ; NHe4 = NHe4 +1
               IF(JTRACK.EQ.-5) IZ=2 ; IA=3 ; NHe3 = NHe3 +1
               IF(JTRACK.EQ.-4) IZ=1 ; IA=3 ; NH3 = NH3 +1
               IF(JTRACK.EQ.-3) IZ=1 ; IA=2 ; NH2 = NH2 +1
               IF(JTRACK.EQ.-2) IZ=ICRES ; IA=IBRES ; NHI = NHI +1
               NuclAfterTUP(1) = JTRACK
               NuclAfterTUP(2) = ETRACK
               NuclAfterTUP(3) = ETRACK-AM(JTRACK)
               NuclAfterTUP(4) = XSCO
               NuclAfterTUP(5) = YSCO
               NuclAfterTUP(6) = ZSCO
               NuclAfterTUP(7) = CXTRCK
               NuclAfterTUP(8) = CYTRCK
               NuclAfterTUP(9) = CZTRCK
               NuclAfterTUP(10)= MREG
               NuclAfterTUP(11)= ICRES
               NuclAfterTUP(12)= IBRES
               NuclAfterTUP(13)= ERES
               NuclAfterTUP(14)= EKRES
               NuclAfterTUP(15)= PXRES
               NuclAfterTUP(16)= PYRES
               NuclAfterTUP(17)= PZRES
              CALL HFN(120,NuclAfterTUP)
            ENDIF
	 ENDIF
      ENDIF

      RETURN
*
*
*======================================================================*
*                                                                      *
*     Event End DRAWing:                                               *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY EEDRAW ( ICODE )

      RETURN
*
*======================================================================*
*                                                                      *
*     ENergy deposition DRAWing:                                       *
*                                                                      *
*     Icode = 1x: CALL from Kaskad                                     *
*             10: elastic interaction recoil                           *
*             11: inelastic interaction recoil                         *
*             12: stopping particle                                    *
*             13: pseudo-neutron deposition                            *
*             14: escape                                               *
*             15: time kill                                            *
*     Icode = 2x: CALL from Emfsco                                     *
*             20: local energy deposition (i.e. photoelectric)         *
*             21: below threshold, iarg=1                              *
*             22: below threshold, iarg=2                              *
*             23: escape                                               *
*             24: time kill                                            *
*     Icode = 3x: CALL from Kasneu                                     *
*             30: target recoil                                        *
*             31: below threshold                                      *
*             32: escape                                               *
*             33: time kill                                            *
*     Icode = 4x: CALL from Kashea                                     *
*             40: escape                                               *
*             41: time kill                                            *
*             42: delta ray stack overflow                             *
*     Icode = 5x: CALL from Kasoph                                     *
*             50: optical photon absorption                            *
*             51: escape                                               *
*             52: time kill                                            *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY ENDRAW ( ICODE, MREG, RULL, XSCO, YSCO, ZSCO )

      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
c         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
c     &          'UNFORMATTED' )
      END IF
C      WRITE (IODRAW)  0, ICODE, JTRACK, SNGL (ETRACK), SNGL (WTRACK)
C      WRITE (IODRAW)  SNGL (XSCO), SNGL (YSCO), SNGL (ZSCO), SNGL (RULL)
*  +-------------------------------------------------------------------*
*  |  Quenching is activated : calculate quenching factor
*  |  AND store quenched energy in DTQUEN(1, jbk)
      IF ( LQEMGD ) THEN
         RULLL = RULL
         CALL QUENMG ( ICODE, MREG, RULLL, DTQUEN )
C         WRITE (IODRAW) ( SNGL (DTQUEN(1, JBK)), JBK = 1, NQEMGD )
      END IF
*  |  end quenching
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     SOurce particle DRAWing:                                         *
*                                                                      *
*======================================================================*
*
      ENTRY SODRAW
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
c         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
c     &          'UNFORMATTED' )
      END IF
C      WRITE (IODRAW) -NCASE, NPFLKA, NSTMAX, SNGL (TKESUM),
C     &                SNGL (WEIPRI)
*  +-------------------------------------------------------------------*
*  |  (Radioactive) isotope: it works only for 1 source particle on
*  |  the stack for the time being
      IF ( ILOFLK (NPFLKA) .GE. 100000 .AND. LRADDC (NPFLKA) ) THEN
         IARES  = MOD ( ILOFLK (NPFLKA), 100000  )  / 100
         IZRES  = MOD ( ILOFLK (NPFLKA), 10000000 ) / 100000
         IISRES = ILOFLK (NPFLKA) / 10000000
         IONID  = ILOFLK (NPFLKA)
C         WRITE (IODRAW) ( IONID,SNGL(-TKEFLK(I)),
C     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
C     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
C     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
C     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
*  |
*  +-------------------------------------------------------------------*
*  |  Patch for heavy ions: it works only for 1 source particle on
*  |  the stack for the time being
      ELSE IF ( ABS (ILOFLK (NPFLKA)) .GE. 10000 ) THEN
         IONID = ILOFLK (NPFLKA)
         CALL DCDION ( IONID )
C         WRITE (IODRAW) ( IONID,SNGL(TKEFLK(I)+AMNHEA(-IONID)),
C     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
C     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
C     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
C     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
*  |
*  +-------------------------------------------------------------------*
*  |  Patch for heavy ions: ???
      ELSE IF ( ILOFLK (NPFLKA) .LT. -6 ) THEN
C         WRITE (IODRAW) ( IONID,SNGL(TKEFLK(I)+AMNHEA(-ILOFLK(NPFLKA))),
C     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
C     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
C     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
C     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
*  |
*  +-------------------------------------------------------------------*
*  |
      ELSE
C         WRITE (IODRAW) ( ILOFLK(I), SNGL (TKEFLK(I)+AM(ILOFLK(I))),
C     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
C     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
C     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
C     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
      END IF
*  |
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     USer dependent DRAWing:                                          *
*                                                                      *
*     Icode = 10x: CALL from Kaskad                                    *
*             100: elastic   interaction secondaries                   *
*             101: inelastic interaction secondaries                   *
*             102: particle decay  secondaries                         *
*             103: delta ray  generation secondaries                   *
*             104: pair production secondaries                         *
*             105: bremsstrahlung  secondaries                         *
*             110: decay products                                      *
*     Icode = 20x: CALL from Emfsco                                    *
*             208: bremsstrahlung secondaries                          *
*             210: Moller secondaries                                  *
*             212: Bhabha secondaries                                  *
*             214: in-flight annihilation secondaries                  *
*             215: annihilation at rest   secondaries                  *
*             217: pair production        secondaries                  *
*             219: Compton scattering     secondaries                  *
*             221: photoelectric          secondaries                  *
*             225: Rayleigh scattering    secondaries                  *
*     Icode = 30x: CALL from Kasneu                                    *
*             300: interaction secondaries                             *
*     Icode = 40x: CALL from Kashea                                    *
*             400: delta ray  generation secondaries                   *
*  For all interactions secondaries are put on GENSTK common (kp=1,np) *
*  but for KASHEA delta ray generation where only the secondary elec-  *
*  tron is present AND stacked on FLKSTK common for kp=npflka          *
*                                                                      *
*======================================================================*
*
      ENTRY USDRAW ( ICODE, MREG, XSCO, YSCO, ZSCO )
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'UNFORMATTED' )
      END IF
* No output by default:

      RETURN
*=== End of subrutine Mgdraw ==========================================*
      END

